;----------------------------------------------------------------------------
; NAME: calendarday
;
; PURPOSE:  Gives the day, month for given julian day and year.
;
; LANGUAGE: IDL
;
; INPUTS:  name     type     dimension       description
;          ----------------------------------------------
;          jday     integer  scalar          julian day of year
;          yr4      integer  scalar          4 digit year
;
; OUTPUT:
;
;          dy       integer  scalar          day of month
;          mn       integer  scalar          month of year
;          leap     integer  scalar          leap year (0 = no, 1 = yes)
;
; CREATION HISTORY:
;                     Darren Jackson CIRES/ETL  December 2002
;-------------------------------------------------------------------------

PRO calendarday, jday, yr4, day, mon2, leap

a=[0,31,59,90,120,151,181,212,243,273,304,334,365]
b=[0,31,60,91,121,152,182,213,244,274,305,335,366]

leap=0
IF (((yr4 mod 4) eq 0 and (yr4 mod 100) ne 0) or (yr4 mod 400) eq 0) THEN leap = 1

mon = 0
WHILE (mon lt 12) DO BEGIN
  mon2 = mon + 1
  IF(leap eq 1) THEN BEGIN
     IF((jday gt b(mon)) and jday le b(mon2)) THEN BEGIN
        day = jday - b(mon)
        RETURN
     ENDIF
  ENDIF ELSE BEGIN
     IF((jday gt a(mon)) and jday le a(mon2)) THEN BEGIN
        day = jday - a(mon)
        RETURN
     ENDIF
  ENDELSE
  mon = mon + 1
ENDWHILE
PRINT,'No day or month found in procedure calenderday'

END
