;----------------------------------------------------------------------------
; NAME: julianday
;
; PURPOSE:  Gives the number of days from beginning of year to day specified. 
;
; LANGUAGE: IDL
;
; INPUTS:  name     type     dimension       description
;          ----------------------------------------------
;          dy       integer  scalar          day of month
;          mn       integer  scalar          month of year
;          yr       integer  scalar          4 digit year
;
; FUNCTION OUTPUT:
;
;          ndays    integer  scalar          day of year (1-366)
;
; CREATION HISTORY:
;                     Darren Jackson CIRES/ETL  January 2001
;-------------------------------------------------------------------------

FUNCTION julianday, dy, mn, yr

a=[0,31,59,90,120,151,181,212,243,273,304,334]
b=[0,31,60,91,121,152,182,213,244,274,305,335]

IF (((yr mod 4) eq 0 and (yr mod 100) ne 0) or (yr mod 400) eq 0) THEN BEGIN
   ndays=b(mn-1)+dy
ENDIF ELSE BEGIN
   ndays=a(mn-1)+dy
ENDELSE

RETURN, ndays
END
