;-----------------------------------------------------------------------------
; NAME: sumcos
;
; PURPOSE: Computes cosine term for LSFCOS procedure
;
; LANGUAGE: IDL
;
; INPUTS:
;           name     type     dimension       description
;     -----------------------------------------------------------------
;           n        long     scalar          Number of time points
;           w        float    scalar          frequency
;
; OUTPUTS:
;           sumcos   float    scalar          Cosine term
;
; CREATION HISTORY:  Darren Jackson CIRES/ETL  June 2002
;------------------------------------------------------------------------------
;
FUNCTION sumcos, n, w

sumcos = cos(0.5*(n-1)*w)*sin(0.5*n*w)/sin(0.5*w)

RETURN, sumcos
END