;-----------------------------------------------------------------------------
; NAME: sumsin
;
; PURPOSE: Computes sine term for LSFCOS procedure
;
; LANGUAGE: IDL
;
; INPUTS:
;           name     type     dimension       description
;     -----------------------------------------------------------------
;           n        long     scalar          Number of time points
;           w        float    scalar          frequency
;
; OUTPUTS:
;           sumsin   float    scalar          Sine term
;
; CREATION HISTORY:  Darren Jackson CIRES/ETL  June 2002
;------------------------------------------------------------------------------
;
FUNCTION sumsin, n, w

sumsin = sin(0.5*(n-1)*w)*sin(0.5*n*w)/sin(0.5*w)

RETURN, sumsin
END