;*************************************************************
; Routine to be used with L2P data
; Time is given in seconds since 1981,jan 1, 0 UTC
; It returns current time in different versions
; jultme = julday.fractme
; julday = julian day
; hh,mm,ss = fractional time in the form of hours, min, sec
; timestr = 'hh:mm:ss '
;*************************************************************
pro secs_since81_utc,time,year,jultme,utchr

leap=[1984,1988,1992,1996,2000,2004,2008,2012]

nonleapyr_secs=86400L*365.
leapyr_secs=86400L*366.

number_of_years=year-1981.
leapyrs_since81=where(year ge leap,number_of_leap)
number_of_nonleap=number_of_years-number_of_leap

secs_upto_prevyr=long(number_of_nonleap*nonleapyr_secs+number_of_leap*leapyr_secs)
;print,secs_upto_prevyr

secs_since_jan1_curryr=time-secs_upto_prevyr

;*  Computing julday and time

jultme=(secs_since_jan1_curryr/86400.d)+1.d
julday=fix(jultme)
utchr=float((jultme-julday)*24.)

;fractime2hhmmss,utchr,hh,mm,ss
;timestr=strcompress(string(hh),/remove_all)+':'+strcompress(string(mm),/remove_all)+':'+strcompress(string(ss),/remove_all)
;print,julday,timestr

end
